/*
 * Copyright (c) 1993 Addison-Wesley Publishing Company.
 * All rights reserved.  This source code is provided
 * for its instructional value, and is not guaranteed
 * for any particular purpose.
 */
#include <sys/types.h>
#include <sys/uio.h>
#include <sys/socket.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>

extern void fatal(const char *, ...);

main(int argc, char *argv[])
{
	int fd;
	struct iovec iov;
	struct msghdr msg;

	if (argc < 2) {
		fprintf(stderr, "usage: %s [args] device\n",
		  argv[0]);
		exit(1);
	}

	/*
	 * Open the device.
	 */
	if ((fd = open(argv[argc-1], O_RDWR)) < 0)
		fatal("%s: cannot open %s", argv[0],
		  argv[argc-1]);

	/*
	 * Perform device-specific initialization.
	 */

	/*
	 * Send the file descriptor for the device back to
	 * the parent using file descriptor 0.
	 */
	iov.iov_base = NULL;
	iov.iov_len = 0;
	msg.msg_iov = &iov;
	msg.msg_iovlen = 1;
	msg.msg_name = NULL;
	msg.msg_accrights = (caddr_t)&fd;
	msg.msg_accrightslen = sizeof(int);
	if (sendmsg(0, &msg, 0) < 0)
		fatal("%s: cannot pass fd", argv[0]);
	exit(0);
}
